// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: registry.proto

/*
Package go_micro_registry is a generated protocol buffer package.

It is generated from these files:
	registry.proto

It has these top-level messages:
	Service
	Node
	Endpoint
	Value
	Options
	Result
	EmptyResponse
	GetRequest
	GetResponse
	ListRequest
	ListResponse
	WatchRequest
	Event
*/
package go_micro_registry

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"

import (
	client "github.com/micro/go-micro/client"
	server "github.com/micro/go-micro/server"
	context "context"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ client.Option
var _ server.Option

// Client API for Registry service

type RegistryClient interface {
	GetService(ctx context.Context, in *GetRequest, opts ...client.CallOption) (*GetResponse, error)
	Register(ctx context.Context, in *Service, opts ...client.CallOption) (*EmptyResponse, error)
	Deregister(ctx context.Context, in *Service, opts ...client.CallOption) (*EmptyResponse, error)
	ListServices(ctx context.Context, in *ListRequest, opts ...client.CallOption) (*ListResponse, error)
	Watch(ctx context.Context, in *WatchRequest, opts ...client.CallOption) (Registry_WatchClient, error)
}

type registryClient struct {
	c           client.Client
	serviceName string
}

func NewRegistryClient(serviceName string, c client.Client) RegistryClient {
	if c == nil {
		c = client.NewClient()
	}
	if len(serviceName) == 0 {
		serviceName = "go.micro.registry"
	}
	return &registryClient{
		c:           c,
		serviceName: serviceName,
	}
}

func (c *registryClient) GetService(ctx context.Context, in *GetRequest, opts ...client.CallOption) (*GetResponse, error) {
	req := c.c.NewRequest(c.serviceName, "Registry.GetService", in)
	out := new(GetResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *registryClient) Register(ctx context.Context, in *Service, opts ...client.CallOption) (*EmptyResponse, error) {
	req := c.c.NewRequest(c.serviceName, "Registry.Register", in)
	out := new(EmptyResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *registryClient) Deregister(ctx context.Context, in *Service, opts ...client.CallOption) (*EmptyResponse, error) {
	req := c.c.NewRequest(c.serviceName, "Registry.Deregister", in)
	out := new(EmptyResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *registryClient) ListServices(ctx context.Context, in *ListRequest, opts ...client.CallOption) (*ListResponse, error) {
	req := c.c.NewRequest(c.serviceName, "Registry.ListServices", in)
	out := new(ListResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *registryClient) Watch(ctx context.Context, in *WatchRequest, opts ...client.CallOption) (Registry_WatchClient, error) {
	req := c.c.NewRequest(c.serviceName, "Registry.Watch", &WatchRequest{})
	stream, err := c.c.Stream(ctx, req, opts...)
	if err != nil {
		return nil, err
	}
	if err := stream.Send(in); err != nil {
		return nil, err
	}
	return &registryWatchClient{stream}, nil
}

type Registry_WatchClient interface {
	SendMsg(interface{}) error
	RecvMsg(interface{}) error
	Close() error
	Recv() (*Result, error)
}

type registryWatchClient struct {
	stream client.Streamer
}

func (x *registryWatchClient) Close() error {
	return x.stream.Close()
}

func (x *registryWatchClient) SendMsg(m interface{}) error {
	return x.stream.Send(m)
}

func (x *registryWatchClient) RecvMsg(m interface{}) error {
	return x.stream.Recv(m)
}

func (x *registryWatchClient) Recv() (*Result, error) {
	m := new(Result)
	err := x.stream.Recv(m)
	if err != nil {
		return nil, err
	}
	return m, nil
}

// Server API for Registry service

type RegistryHandler interface {
	GetService(context.Context, *GetRequest, *GetResponse) error
	Register(context.Context, *Service, *EmptyResponse) error
	Deregister(context.Context, *Service, *EmptyResponse) error
	ListServices(context.Context, *ListRequest, *ListResponse) error
	Watch(context.Context, *WatchRequest, Registry_WatchStream) error
}

func RegisterRegistryHandler(s server.Server, hdlr RegistryHandler, opts ...server.HandlerOption) {
	s.Handle(s.NewHandler(&Registry{hdlr}, opts...))
}

type Registry struct {
	RegistryHandler
}

func (h *Registry) GetService(ctx context.Context, in *GetRequest, out *GetResponse) error {
	return h.RegistryHandler.GetService(ctx, in, out)
}

func (h *Registry) Register(ctx context.Context, in *Service, out *EmptyResponse) error {
	return h.RegistryHandler.Register(ctx, in, out)
}

func (h *Registry) Deregister(ctx context.Context, in *Service, out *EmptyResponse) error {
	return h.RegistryHandler.Deregister(ctx, in, out)
}

func (h *Registry) ListServices(ctx context.Context, in *ListRequest, out *ListResponse) error {
	return h.RegistryHandler.ListServices(ctx, in, out)
}

func (h *Registry) Watch(ctx context.Context, stream server.Streamer) error {
	m := new(WatchRequest)
	if err := stream.Recv(m); err != nil {
		return err
	}
	return h.RegistryHandler.Watch(ctx, m, &registryWatchStream{stream})
}

type Registry_WatchStream interface {
	SendMsg(interface{}) error
	RecvMsg(interface{}) error
	Close() error
	Send(*Result) error
}

type registryWatchStream struct {
	stream server.Streamer
}

func (x *registryWatchStream) Close() error {
	return x.stream.Close()
}

func (x *registryWatchStream) SendMsg(m interface{}) error {
	return x.stream.Send(m)
}

func (x *registryWatchStream) RecvMsg(m interface{}) error {
	return x.stream.Recv(m)
}

func (x *registryWatchStream) Send(m *Result) error {
	return x.stream.Send(m)
}
